// $Id: tahash.cc 3877 2011-03-25 23:29:55Z flaterco $

/*
    TA (Transparent Archivist) (C) 2005 David Flater.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <assert.h>
#include <Dstr>
#include <stdio.h>
#include <stdlib.h>
#include "ta-util.hh"


int main (int argc, char **argv) {
  printf ("\
    TA (Transparent Archivist) Version %s (C) 2005 David Flater.\n\
\n\
    This program is free software: you can redistribute it and/or modify\n\
    it under the terms of the GNU General Public License as published by\n\
    the Free Software Foundation, either version 3 of the License, or\n\
    (at your option) any later version.\n\
\n\
    This program is distributed in the hope that it will be useful,\n\
    but WITHOUT ANY WARRANTY; without even the implied warranty of\n\
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n\
    GNU General Public License for more details.\n\
\n\
    You should have received a copy of the GNU General Public License\n\
    along with this program.  If not, see <http://www.gnu.org/licenses/>.\n\
\n", ta_version);

  if (argc != 2) {
    fprintf (stderr, "Usage: tahash dir\n");
    exit (-1);
  }

  Dstr wdpath (argv[1]);
  slashterm (wdpath);

  Dstr hashfilename;
  getTarget ("ta-hashes.txt", wdpath, hashfilename);

  printf ("Hashing source files\n");
  FileList flist;
  addSomething (wdpath, flist, false, false);

  // Because we are skipping the file-moving step that ta does, we
  // need to strip the leading directories off the file names.  This
  // obviates the need to fix up . and .. references in addSomething.
  unsigned trunc = wdpath.length();
  for (FileListIndex ptr=0; ptr<flist.size(); ++ptr)
    flist[ptr].name /= trunc;

  try {
    write_hashes (wdpath, flist, flist.size());
  } catch (FileWriteException) {
    fprintf (stderr, "Error writing ta-hashes.txt in directory.  Trying to save in /tmp instead...\n");
    write_hashes ("/tmp/", flist, flist.size());
  }

  return 0;
}
